Index: branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 1200)
@@ -533,4 +610,20 @@
     }
   }
+
+  template <typename T>
+  Void xResizeVector(  std::vector<T> & rpcVector, UInt n )
+  {
+    for( Int layer = 0; rpcVector.size() < n; layer++ )
+    {
+      assert( rpcVector.size() > 0 );
+      rpcVector.push_back( rpcVector[layer] );      
+    }
+
+    for( ; rpcVector.size() > n; )
+    {      
+      rpcVector.pop_back( );      
+    }
+  }
+
 
   template <typename T>
@@ -561,5 +654,5 @@
   Void xPrintVectorElem( Bool   elem ) { printf(" %d"   , ( elem ? 1 : 0 ));};
 #endif
-#if H_MV
+#if NH_MV
   Int   getGOPSize() { return m_iGOPSize; }
 #endif
@@ -567,10 +660,10 @@
   TAppEncCfg();
   virtual ~TAppEncCfg();
-  
+
 public:
   Void  create    ();                                         ///< create option handling class
   Void  destroy   ();                                         ///< destroy option handling class
   Bool  parseCfg  ( Int argc, Char* argv[] );                 ///< parse configuration file to fill member variables
-  
+
 };// END CLASS DEFINITION TAppEncCfg
 
Index: branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -42,4 +42,5 @@
 #include <fcntl.h>
 #include <assert.h>
+#include <iomanip>
 
 #include "TAppEncTop.h"
@@ -58,5 +59,5 @@
 {
 
-#if H_MV
+#if NH_MV
   m_vps = new TComVPS; 
 #else
@@ -69,5 +70,5 @@
 TAppEncTop::~TAppEncTop()
 {
-#if H_MV
+#if NH_MV
   if (m_vps)
   {
@@ -80,5 +81,5 @@
 Void TAppEncTop::xInitLibCfg()
 {
-#if H_MV
+#if NH_MV
   TComVPS& vps = (*m_vps);   
 #else
@@ -86,10 +87,13 @@
 #endif
   
+#if NH_3D
+  vps.createCamPars(m_iNumberOfViews);  
+#endif
+
 #if H_3D
-  vps.createCamPars(m_iNumberOfViews);
   TComDLT& dlt = m_dlt;
 #endif
 
-#if H_MV
+#if NH_MV
   Int maxTempLayer = -1; 
   for (Int j = 0; j < m_numberOfLayers; j++)
@@ -118,17 +122,19 @@
   }
 #else
-  vps.setMaxTLayers                       ( m_maxTempLayer );
+  vps.setMaxTLayers                                               ( m_maxTempLayer );
   if (m_maxTempLayer == 1)
   {
     vps.setTemporalNestingFlag(true);
   }
-  vps.setMaxLayers                        ( 1 );
+  vps.setMaxLayers                                                ( 1 );
   for(Int i = 0; i < MAX_TLAYER; i++)
   {
-    vps.setNumReorderPics                 ( m_numReorderPics[i], i );
-    vps.setMaxDecPicBuffering             ( m_maxDecPicBuffering[i], i );
-  }
-#endif
-#if H_MV
+    vps.setNumReorderPics                                         ( m_numReorderPics[i], i );
+    vps.setMaxDecPicBuffering                                     ( m_maxDecPicBuffering[i], i );
+  }
+#endif
+#if NH_MV
+  xSetTimingInfo           ( vps );
+  xSetHrdParameters        ( vps ); 
   xSetLayerIds             ( vps );   
   xSetDimensionIdAndLength ( vps );
@@ -139,7 +145,9 @@
   xSetDpbSize              ( vps ); 
   xSetVPSVUI               ( vps ); 
-#if H_3D
+#if NH_3D
   xSetCamPara              ( vps ); 
   m_ivPicLists.setVPS      ( &vps );
+#endif
+#if H_3D
   xDeriveDltArray          ( vps, dlt );
 #endif
@@ -174,7 +182,6 @@
   }
 
-#if H_3D
+#if NH_3D
   // Set 3d tool parameters
-
   for (Int d = 0; d < 2; d++)
   {  
@@ -201,4 +208,7 @@
   }
 #endif
+
+
+  /// Create encoders and set profiles profiles
   for(Int layerIdInVps = 0; layerIdInVps < m_numberOfLayers; layerIdInVps++)
   {
@@ -207,5 +217,47 @@
     m_acTVideoIOYuvInputFileList.push_back(new TVideoIOYuv);
     m_acTVideoIOYuvReconFileList.push_back(new TVideoIOYuv);
-    m_picYuvRec                 .push_back(new TComList<TComPicYuv*>) ;
+#if NH_3D    
+    Int profileIdc = -1; 
+    for (Int olsIdx = 0; olsIdx < vps.getNumOutputLayerSets(); olsIdx++ )
+    {   
+      Int lsIdx = vps.olsIdxToLsIdx( olsIdx );
+      for(Int i = 0; i < vps.getNumLayersInIdList( lsIdx ); i++ )
+      {
+        if( vps.getLayerIdInNuh( layerIdInVps) == vps.getLayerSetLayerIdList(lsIdx, i) )
+        {
+          Int ptlIdx = vps.getProfileTierLevelIdx( olsIdx, i );
+          if ( ptlIdx != -1 )
+          {
+            Int curProfileIdc = vps.getPTL(ptlIdx)->getGeneralPTL()->getProfileIdc(); 
+            if (profileIdc == -1)   
+            {
+              profileIdc = curProfileIdc; 
+            }
+            else
+            {   
+              if ( profileIdc != curProfileIdc )
+              {              
+                fprintf(stderr, "Error: ProfileIdc for layer with index %d in VPS not equal in all OLSs. \n", layerIdInVps );
+                exit(EXIT_FAILURE);
+              }
+            }
+          }
+        }
+      }
+    }
+
+    if (profileIdc == -1 )
+    {
+      fprintf(stderr, "Error: No profile given for layer with index %d in VPS not equal in all OLS. \n", layerIdInVps );
+      exit(EXIT_FAILURE);
+    }
+    m_acTEncTopList[ layerIdInVps ]->setProfileIdc( profileIdc ); 
+#endif
+  }
+
+
+  for(Int layerIdInVps = 0; layerIdInVps < m_numberOfLayers; layerIdInVps++)
+  {
+    m_cListPicYuvRec            .push_back(new TComList<TComPicYuv*>) ;
     m_ivPicLists.push_back( m_acTEncTopList[ layerIdInVps ]->getListPic()  ); 
     TEncTop& m_cTEncTop = *m_acTEncTopList[ layerIdInVps ];  // It is not a member, but this name helps avoiding code duplication !!!
@@ -216,10 +268,10 @@
     m_cTEncTop.setViewId                       ( vps.getViewId      (  layerId ) );
     m_cTEncTop.setViewIndex                    ( vps.getViewIndex   (  layerId ) );
-#if H_3D
+#if NH_3D
     Bool isDepth = ( vps.getDepthId     ( layerId ) != 0 ) ;
     m_cTEncTop.setIsDepth                      ( isDepth );
     //====== Camera Parameters =========
     m_cTEncTop.setCameraParameters             ( &m_cCameraData );     
-#if H_3D_VSO
+#if NH_3D_VSO
     //====== VSO =========
     m_cTEncTop.setRenderModelParameters        ( &m_cRenModStrParser ); 
@@ -249,11 +301,9 @@
     m_cTEncTop.setUseDLT                       ( isDepth ? m_useDLT   : false );
     m_cTEncTop.setUseQTL                       ( isDepth ? m_bUseQTL  : false );
-
-
-  m_cTEncTop.setSps3dExtension                 ( m_sps3dExtension );
+    m_cTEncTop.setSps3dExtension               ( m_sps3dExtension );
 #endif // H_3D
 
     m_cTEncTop.setIvPicLists                   ( &m_ivPicLists ); 
-#endif  // H_MV
+#endif  // NH_MV
   m_cTEncTop.setVPS(&vps);
 
